//Buggy control with Clicker2 for STM32

#include "Blep.h"

sbit BREAK_LAMPS at GPIO_PIN42_bit;
sbit HEAD_LAMPS at GPIO_PIN60_bit;
sbit TURN_L at GPIO_PIN6_bit;
sbit TURN_R at GPIO_PIN43_bit;
sbit MAIN_BEAM at GPIO_PIN63_bit;
extern pokreni_Buggy;

//BUGGY COMMANDS
#define CMD_DRIVE                0x01
#define CMD_BREAK                0x02
#define CMD_RESPOND              0x03
#define CMD_SPIN                 0x04
#define CMD_AUTO                 0x05
#define MAX_LENGTH1              0x14
#define MAX_LENGTH2              0x14
unsigned int SPEED_L;
unsigned int SPEED_R;

unsigned int PWM_A_PERIOD;
unsigned int PWM_B_PERIOD;
unsigned int PWM_C_PERIOD;
unsigned int PWM_D_PERIOD;
unsigned int timerStart = 0;
extern char writeBuff[32];
extern short readBuff[32];

char old_cmd = CMD_BREAK;
char txPipe;
int br = 0;
//added declarations for auto_control
unsigned int SPEED_L1;
unsigned int SPEED_R1;

unsigned int PWM_PERIOD;
volatile double dbl_temp1;
unsigned char leftRight = 0;
unsigned char action    = 0;
unsigned int cnt1       = 0;
unsigned int number = 0;
unsigned char BuggyDisc;
enum turns {left, right, stop};

enum turns circle = left;

//functions for auto_control
void TimerInterrupt() iv IVT_TIMERS_IRQ
{
  cnt1 += 1;
  if ( (cnt1 == 180) && (circle == left) )
  {
    leftRight = ~leftRight;
    cnt1 = 0;
    action = 0;
  }

  if ( (cnt1 == 140) && (circle == right) )
  {
    leftRight = ~leftRight;
    cnt1 = 0;
    action = 0;
  }
  if((circle==stop)&& (cnt1 == 500))
  {
    circle = left;
    cnt1 = 0;
    action = 0;
  }

  TIMER_INT.B2 = 1;
}

void StartTimerB()
{
  TIMER_CONTROL_1.B1 = 1;
}

void StopTimerB()
{
  TIMER_CONTROL_1.B5 = 1;
}

void InitTimerB() {
  TIMER_CONTROL_0 = 2;
  TIMER_SELECT = 1;
  TIMER_PRESC_LS = 36;
  TIMER_PRESC_MS = 244;
  TIMER_WRITE_LS = 15;
  TIMER_WRITE_MS = 0;
  TIMER_CONTROL_3 = 0;
  TIMER_CONTROL_4 = 18;
  TIMER_CONTROL_2 = 32;
  TIMER_INT = 8;
  IRQ_CTRL.B31 = 0;
}

void Init_Buggy1() {

//PWM
  SPEED_L1 = 0;
  SPEED_R1 = 0;
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_4);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_5);;
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
}
void Break_Buggy1()
{
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_5);
  PWM_ConfigChannel(0,_PWM_INIT_STATE_1, _PWM_CHANNEL_4);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
}

void Start_Buggy1()
{

  PWM_EnableOutput();
  Break_Buggy1();
}
void Drive_Buggy1(char vel_left , char vel_right )
{

  // left motors calculation
  // Convert received speed in %
  dbl_temp1 = (double)vel_left / 100;
  SPEED_L1 = (unsigned int) (PWM_PERIOD * dbl_temp1);

  // right motors calculation
  // Convert received speed in %
  dbl_temp1 = (double)vel_right / 100;
  SPEED_R1 = (unsigned int) (PWM_PERIOD * dbl_temp1);

  // set DC
  // left-side PWM
  PWM_ConfigChannel(0,       _PWM_INIT_STATE_1, _PWM_CHANNEL_4);
  PWM_ConfigChannel(SPEED_L1, _PWM_INIT_STATE_1, _PWM_CHANNEL_5);
  Delay_ms(10);

  // right-side PWM
  PWM_ConfigChannel(0,       _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
  PWM_ConfigChannel(SPEED_R1, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
  Delay_ms(10);

  if ( vel_left < vel_right)
    circle = left;
  else if ( vel_left > vel_right)
    circle = right;
}

void Buggy_Auto_Control() {

  if (action == 0)
  {
    if(number == 8)
    {
     Break_Buggy1();
     circle = stop;
     action = 1;
     number = 0;
    }
    if ((leftRight == 0)&&(circle != stop))
    {
      // drive left
      Drive_Buggy1(25, 100);
      action = 1;
      number++;
    }
    else if ((leftRight == 0xFF)&&(circle!=stop))
    {
      // drive right
      Drive_Buggy1(100, 25);
      action = 1;
      number++;
    }
  }
}



void Init_Buggy() {

  // init pin 42
  GPIO_Pin_Digital_Output(42);
  
  //init pin 60
  GPIO_Pin_Digital_Output(60);

  // init pin 6
  GPIO_Pin_Digital_Output(6);
  
  //init pin 43
  GPIO_Pin_Digital_Output(43);
  
  // init pin 63
  GPIO_Pin_Digital_Output(63);
  
//BAT VSENSE
// PIN9 is input for battery_voltage
  ADC_Set_Input_Channel(_ADC_CHANNEL_4); //ADC
  ADC_Init();
  
//PWM
  SPEED_L = 0;
  SPEED_R = 0;
  PWM_A_PERIOD = PWM_Init(20000);
  PWM_B_PERIOD = PWM_Init(20000);
  PWM_C_PERIOD = PWM_Init(20000);
  PWM_D_PERIOD = PWM_Init(20000);
  PWM_PERIOD = PWM_A_PERIOD;
  PWM_ConfigChannel(0,_PWM_INIT_STATE_0, _PWM_CHANNEL_5);
  PWM_ConfigChannel(0,_PWM_INIT_STATE_0, _PWM_CHANNEL_4);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_0, _PWM_CHANNEL_6);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_0, _PWM_CHANNEL_7);
}

void HeadLamps_Blink() {
  HEAD_LAMPS = 1;
  delay_ms(200);
  HEAD_LAMPS = 0;
  delay_ms(500);
  HEAD_LAMPS = 1;
  delay_ms(200);
  HEAD_LAMPS = 0;
}

void TurnLamps_Blink() {
  char n;
  
  for(n=0; n<7; n++) {
    TURN_L = ~ TURN_L;
    TURN_R = ~ TURN_R;
    delay_ms(200);
  }
  TURN_L = 0;
  TURN_R = 0;
}

void Lights_Off() {

}

void Break_Buggy() {
  SPEED_L = 0;
  SPEED_R = 0;
  PWM_ConfigChannel(0,_PWM_INIT_STATE_1, _PWM_CHANNEL_5);
  PWM_ConfigChannel(0,_PWM_INIT_STATE_1, _PWM_CHANNEL_4);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
  PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
}


static void Test_Drive() {
  Break_Buggy();
  PWM_ConfigChannel(PWM_A_PERIOD >>1,_PWM_INIT_STATE_1, _PWM_CHANNEL_5);
  PWM_ConfigChannel(PWM_D_PERIOD >>1, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
  delay_ms(5000);
  Break_Buggy();
  PWM_ConfigChannel(PWM_B_PERIOD>>1,_PWM_INIT_STATE_1, _PWM_CHANNEL_4);
  PWM_ConfigChannel(PWM_C_PERIOD>>1, _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
  delay_ms(5000);
  Break_Buggy();
}

static void Full_Circle_Left() {
  double dbl_temp = (double)readBuff[6] / 100;
  unsigned int spin_speed;
  Break_Buggy();
  spin_speed = (unsigned int) (PWM_D_PERIOD * dbl_temp);
  PWM_ConfigChannel(spin_speed, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
  spin_speed = (unsigned int) (PWM_B_PERIOD * dbl_temp);
  PWM_ConfigChannel(spin_speed,_PWM_INIT_STATE_1, _PWM_CHANNEL_4);
  TURN_L = ~TURN_L;
  TURN_R = ~TURN_R;
}

static void Full_Circle_Right() {
  double dbl_temp = (double)readBuff[6] / 100;
  unsigned int spin_speed;
  Break_Buggy();
  spin_speed = (unsigned int) (PWM_A_PERIOD * dbl_temp);
  PWM_ConfigChannel(spin_speed,_PWM_INIT_STATE_1, _PWM_CHANNEL_5);
  spin_speed = (unsigned int) (PWM_C_PERIOD * dbl_temp);
  PWM_ConfigChannel(spin_speed, _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
  TURN_L = ~TURN_L;
  TURN_R = ~TURN_R;
}

void Start_Buggy() {

  PWM_EnableOutput();
  TurnLamps_Blink();
  Break_Buggy();
}

volatile double dbl_temp;
void Drive_Buggy() {
   int i = 0;
   char dir = readBuff[5];
   char vel_left = readBuff[6];
   char vel_right = readBuff[7];

   if (dir != 0) { //reverse direction
       //left motors
       dbl_temp = (double)vel_left / 100;                                        //Convert received speed in %
       SPEED_L = (unsigned int) (PWM_B_PERIOD * dbl_temp);
       PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_5);
       PWM_ConfigChannel(SPEED_L, _PWM_INIT_STATE_1, _PWM_CHANNEL_4);
       //right motors
       dbl_temp = (double)vel_right / 100;
       SPEED_R = (unsigned int) (PWM_C_PERIOD * dbl_temp);
       PWM_ConfigChannel(0, _PWM_INIT_STATE_1, _PWM_CHANNEL_7);
       PWM_ConfigChannel(SPEED_R, _PWM_INIT_STATE_1, _PWM_CHANNEL_6);
   }else{ //forward direction
       //left motors
       dbl_temp = (double)vel_left / 100;                                        //Convert received speed in %
       SPEED_L = (unsigned int) (PWM_A_PERIOD * dbl_temp);
       PWM_ConfigChannel(0, _PWM_INIT_STATE_1,_PWM_CHANNEL_4);
       PWM_ConfigChannel(SPEED_L, _PWM_INIT_STATE_1, _PWM_CHANNEL_5);
       
       
       dbl_temp = (double)vel_right / 100;
       SPEED_R = (unsigned int) (PWM_D_PERIOD * dbl_temp);
       PWM_ConfigChannel(0,_PWM_INIT_STATE_1, _PWM_CHANNEL_6);
       PWM_ConfigChannel(SPEED_R,_PWM_INIT_STATE_1, _PWM_CHANNEL_7);
       
       }
}

static void SetBattValueToBuffer(unsigned int Value){
  //Divide to 4x4bit value
  writeBuff[0] = (char)((Value >> 12)& 0xF); //HHHsb
  writeBuff[1] = (char)((Value >> 8)& 0xF);  //HHsb
  writeBuff[2] = (char)((Value >> 4) & 0xF); //Hsb
  writeBuff[3] = (char)(Value & 0xF);        //Lsb
}

//Message format:
//readBuff[0] - Message Lenght
//readBuff[1] - Event
//readBuff[2] - Service Pipe No.
//readBuff[3...20] - Received data
int temp_int;
void OnDataReceived() {

  char next_cmd = readBuff[4]; 
  switch (next_cmd) {
    case CMD_DRIVE:
      Drive_Buggy();
      break;
    case CMD_BREAK:
       Break_Buggy();
       if (timerStart == 1)
       {
         timerStart = 0;
         StopTimerB();
       }
      break;
    case CMD_SPIN:
      if (old_cmd != CMD_SPIN) {
          TURN_L = 0;
          TURN_R = 0;
      }
      
      if (readBuff[5] != 0) {
         Full_Circle_Left();
      }else{
         Full_Circle_Right();
      }
      break;
    case CMD_RESPOND:
      asm nop;
      break;
    case CMD_AUTO:
    if (timerStart == 0)
    {
      timerStart = 1;
      StartTimerB();
    }
    Buggy_Auto_Control();
    break;
    default: 
      Break_Buggy();
  }
  
  //lights control

  BREAK_LAMPS = readBuff[8] & 0x01;
  MAIN_BEAM = readBuff[8] >> 3;
  HEAD_LAMPS = readBuff[8] >> 4;
  if (next_cmd != CMD_SPIN) {
    if (readBuff[8] & 0x02) {
      TURN_L = ~TURN_L;
    }else{
      TURN_L = 0;
    }
  
    if (readBuff[8] & 0x04) {
      TURN_R = ~TURN_R;
    } else{
      TURN_R = 0;
    }
  
  }

  //turn off turn lights after spining
  if (next_cmd != old_cmd) {
    if (old_cmd == CMD_SPIN) {
      TURN_L = 0;
      TURN_R = 0;
    }
  }

  old_cmd = next_cmd;
  txPipe = readBuff[2] + 1;
  temp_int = ADC_Get_Sample(4);
  SetBattValueToBuffer(temp_int);
  Blep_SendData(&writeBuff,6,TxPipe);
  
}